﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Workflow.Activities

Namespace LCContracts
	<ExternalDataExchange> _
	Public Interface ITaskService
		Sub CreateTask(ByVal newTask As Task, ByVal defaultUser As String)
		Sub AssignTask(ByVal task As Task, ByVal user As String)
		'void DeleteTask(Task task, string reason);
		Event TaskCompleted As EventHandler(Of TaskEventArgs)
	End Interface

	<Serializable> _
	Public Class TaskEventArgs
		Inherits ExternalDataEventArgs
		Public Sub New(ByVal instanceId As Guid, ByVal task As Task)
			MyBase.New(instanceId)
			Me.Task = task
			MyBase.WaitForIdle = True
		End Sub

		Private privateTask As Task
		Public Property Task() As Task
			Get
				Return privateTask
			End Get
			Set(ByVal value As Task)
				privateTask = value
			End Set
		End Property
	End Class

	<Serializable> _
	Public Class Task
		Private privateName As String
		Public Property Name() As String
			Get
				Return privateName
			End Get
			Set(ByVal value As String)
				privateName = value
			End Set
		End Property
		Private privateDescription As String
		Public Property Description() As String
			Get
				Return privateDescription
			End Get
			Set(ByVal value As String)
				privateDescription = value
			End Set
		End Property
		Private privatePriority As Integer
		Public Property Priority() As Integer
			Get
				Return privatePriority
			End Get
			Set(ByVal value As Integer)
				privatePriority = value
			End Set
		End Property
		Private privateDateDue As DateTime
		Public Property DateDue() As DateTime
			Get
				Return privateDateDue
			End Get
			Set(ByVal value As DateTime)
				privateDateDue = value
			End Set
		End Property

		Public Overrides Function ToString() As String
			Return String.Format("{0}:{1}", Name, DateDue)
		End Function
	End Class
End Namespace
