﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.Workflow.Runtime
Imports System.Workflow.Runtime.Hosting
Imports System.Workflow.Activities
Imports LCContracts
Imports LCContractsV2

Namespace LocalCommunications
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Using workflowRuntime As New WorkflowRuntime()
				Dim eds As New ExternalDataExchangeService()
				workflowRuntime.AddService(eds)
				Dim ts As TaskService = New TaskService2()
				eds.AddService(ts)


				Dim sql As New SqlWorkflowPersistenceService("server=.;database=workflowpersistence;integrated security=SSPI", True, New TimeSpan(0,2,0), New TimeSpan(0,2,0))

				workflowRuntime.AddService(sql)

				workflowRuntime.StartRuntime()

				Dim waitHandle As New AutoResetEvent(False)
				AddHandler workflowRuntime.WorkflowCompleted, Function(sender, e) AnonymousMethod1(sender, e, waitHandle)
				AddHandler workflowRuntime.WorkflowTerminated, Function(sender, e) AnonymousMethod2(sender, e, waitHandle)


				If args.Length = 0 Then
					For i As Integer = 0 To 9
						Dim instance As WorkflowInstance = workflowRuntime.CreateWorkflow(GetType(LocalCommunications.Workflow1))
						instance.Start()
						Console.WriteLine("Started: {0}", instance.InstanceId)
					Next i

				Else
					For Each i As SqlPersistenceWorkflowInstanceDescription In sql.GetAllWorkflows()
						Dim id As Guid = i.WorkflowInstanceId
						ts.OnTaskCompleted(New Task With {.DateDue = DateTime.Now.AddDays(1), .Description = "some task description", .Name = "Do work", .Priority = 1}, id)
					Next i
				End If

				Console.ReadLine()
			End Using
		End Sub
		
		Private Shared Function AnonymousMethod1(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs, ByVal waitHandle As AutoResetEvent) As Boolean
			waitHandle.Set()
			Return True
		End Function
		
		Private Shared Function AnonymousMethod2(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs, ByVal waitHandle As AutoResetEvent) As Boolean
			Console.WriteLine(e.Exception.Message)
			waitHandle.Set()
			Return True
		End Function
	End Class
End Namespace
