﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.Workflow.Runtime
Imports System.Workflow.Runtime.Hosting
Imports System.Workflow.ComponentModel
Imports System.Workflow.ComponentModel.Serialization
Imports System.Runtime.Serialization

Namespace SimpleWorkflows
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Using workflowRuntime As New WorkflowRuntime()
				Dim sql As New SqlWorkflowPersistenceService("server=.;database=workflowpersistence;integrated security=SSPI", True, New TimeSpan(0, 2, 0), New TimeSpan(0, 0, 10))
				workflowRuntime.AddService(sql)

				workflowRuntime.StartRuntime()

				Dim instance As WorkflowInstance = Nothing

				Dim waitHandle As New AutoResetEvent(False)
				AddHandler workflowRuntime.WorkflowCompleted, Function(sender, e) AnonymousMethod1(sender, e, waitHandle)
				AddHandler workflowRuntime.WorkflowTerminated, Function(sender, e) AnonymousMethod2(sender, e, waitHandle)
				AddHandler workflowRuntime.WorkflowIdled, Function(sender, wie) AnonymousMethod3(sender, wie, instance)
				AddHandler workflowRuntime.ServicesExceptionNotHandled, Function(sender, snh) AnonymousMethod4(sender, snh)

				instance = workflowRuntime.CreateWorkflow(GetType(SimpleWorkflows.Workflow1))
				instance.Start()

				waitHandle.WaitOne()
				Console.ReadLine()

			End Using
		End Sub
		
		Private Shared Function AnonymousMethod1(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs, ByVal waitHandle As AutoResetEvent) As Boolean
			waitHandle.Set()
			Return True
		End Function
		
		Private Shared Function AnonymousMethod2(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs, ByVal waitHandle As AutoResetEvent) As Boolean
			Console.ForegroundColor = ConsoleColor.Yellow
			Console.WriteLine(e.Exception.Message)
			Console.ResetColor()
			waitHandle.Set()
			Return True
		End Function
		
		Private Shared Function AnonymousMethod3(ByVal sender As Object, ByVal wie As WorkflowEventArgs, ByVal instance As WorkflowInstance) As Boolean
			ThreadPool.QueueUserWorkItem(New WaitCallback(Function(state) AnonymousMethod5(state, instance)))
			Return True
		End Function
		
		Private Shared Function AnonymousMethod5(ByVal state As Object, ByVal instance As WorkflowInstance) As Boolean
			Dim changes As New WorkflowChanges(instance.GetWorkflowDefinition())
			Dim root As CompositeActivity = changes.TransientWorkflow
			Dim wl As WriteLineActivity = New WriteLineActivity With {.Name = "newWriteLine", .OutputText = "dynamically added"}
			root.Activities.Add(wl)
			instance.ApplyWorkflowChanges(changes)
			Return True
		End Function
		
		Private Shared Function AnonymousMethod4(ByVal sender As Object, ByVal snh As ServicesExceptionNotHandledEventArgs) As Boolean
			Console.ForegroundColor = ConsoleColor.Yellow
			Console.WriteLine(snh.Exception.Message)
			Console.ResetColor()
			Return True
		End Function
	End Class
End Namespace
